#include "cv.h"
#include "highgui.h"
#include <math.h>




int* cvHist(IplImage *Obr, int visible, int potlac);
//vraci ukazatel na pole velikosti 256, kde kazdy prvek obsahuje cetnost daneho jasu v obraze
//provede vypocet histogramu z obrazu Obr
//promenna visible udava jestli se ma zobrazovat histogram =1 ci nikoliv =0
//promenna potlac udava jas ktery se nema vykreslit

IplImage* cvImageAdjust(IplImage *Obr,double x1,double y1,double x2,double y2);
//provede zmenu jasu obrazu
//parametry jsou obraz, vysledek, souradnice primky, podle niz jas menime

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez);
//proved rotaci obrazu Obr o uhel uhel
//jestlize orez=0 pak bude vyseldny obraz vetsi nez vzorovy ovsem cely, jinak se obraz orizne
//na velikost originalu

int main( int argc, char** argv )
{
	IplImage *obr;
	IplImage *gray;
	IplImage *prah;
	IplImage *zmenseny;
	IplImage *vys;
	IplImage *rotovany;

	int *Histogram;

	int Hodnota=200;//nastaveni pocatecni hodnoty posuvniku
	int c;

	cvNamedWindow( "Okno",1);//vytvori okno na ktere se odkazujeme pomoci jmena
	
	cvCreateTrackbar( "Posuvnik", "Okno", &Hodnota, 1000, 0 );//vztvoreni posuvniku jeho hodnota se uklada do promenne int


	obr = cvLoadImage ( "jpg.jpg",-1);//nacte obraz
	gray = cvCreateImage ( cvGetSize(obr), 8, 1);// vztvoreni hlavycky obrazu a alokovani pameti


	cvShowImage("Okno",obr);//zobrazi obraz do predem vytvoreneho okna
	printf("**stiskni klavesu**\n");
	cvCvtColor( obr, gray, CV_BGR2GRAY);
	Histogram = cvHist(gray,1,255);//toto je moje funkce v openCV existuje fce pro histogram ale upravil jsem si ji
	//v openCV existuje i funkce pro normalizaci histogramu je to cvNormalizeHist, ale aby jste ji mohli pouzivat musite
	//pouzit standartni vypocet histogramu pomoci openCV, najdete ho v helpu pod pojmem Histograms v CV Reference Manual 
	printf("cetnost jasu 255 je %i\n",Histogram[255]);
	c = cvWaitKey(0);//cekani na klavesu v milisekundach

	printf("zesvetleni obrazu\n");
	printf("**stiskni klavesu**\n");
	vys = cvImageAdjust(obr,0,0.3,0.7,1);//zesvetleni obrazu
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach

	printf("ztmaveni obrazu\n");
	printf("**stiskni klavesu**\n");
	vys = cvImageAdjust(obr,0.3,0,1,0.7);//ztmaveni obrazu
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach

	printf("zvyseni kontrastu\n");
	printf("**stiskni klavesu**\n");
	vys = cvImageAdjust(obr,0.3,0,0.7,1);//zvyseni kontrastu obrazu
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	printf("snizeni kontrastu\n");
	printf("**stiskni klavesu**\n");
	vys = cvImageAdjust(obr,0,0.3,1,0.7);//snizeni kontrastu obrazu
	cvShowImage("Okno",vys);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach

	printf("naprahovany obraz na hodnotu 30\n");
	printf("**stiskni klavesu**\n");
	prah = cvCreateImage ( cvGetSize(gray), 8, 1);// vztvoreni hlavycky obrazu a alokovani pameti
	cvThreshold( gray, prah, 30, 255, CV_THRESH_BINARY_INV);
	//prahovani danou hodnotou 30, parametry jsou zdrojovy obraz, vysledny obraz, prah, maximalni 
	//hodnota na trerou se nastavuje vysledek, metoda prahovani
	cvShowImage("Okno",prah);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	//geometricke transformace
	printf("zmenseni obrazu\n");
	printf("**stiskni klavesu**\n");
	zmenseny = cvCreateImage ( cvSize(obr->width/2,obr->height/2), 8, 3);// vztvoreni hlavycky obrazu a alokovani pameti
	cvResize(obr, zmenseny, CV_INTER_NN );
	//zmena velikosti, velikost vyslednejho obrazu je dana pri vytvoreni jeho hlavicky, v nasem pripade polovicni
	//parametry jsou puvodni obraz, zmenseny obraz, metoda pro zmenseni
	cvShowImage("Okno",zmenseny);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
	printf("rotace obrazu o uhel 45\n");
	printf("**stiskni klavesu**\n");
	rotovany=cvImageRotate(obr,45,1);
	cvShowImage("Okno",rotovany);//zobrazi obraz do predem vytvoreneho okna
	c = cvWaitKey(0);//cekani na klavesu v milisekundach
	
    
    cvDestroyWindow("Okno");//uvolneni okna    
	cvReleaseImage(&obr);//uvolneni pameti
	cvReleaseImage(&gray);//uvolneni pameti
	cvReleaseImage(&rotovany);//uvolneni pameti
	cvReleaseImage(&prah);//uvolneni pameti
	cvReleaseImage(&zmenseny);//uvolneni pameti
    return 0;
}




int* cvHist(IplImage *Obr, int visible, int potlac)
//vypocet histogramu
//promena potlac udava hodnotu ktera se nema vykreslit
{
	int i,j,max=0;
	int *Hist;//pole pro umisteni hodnot histogramu
	IplImage *Histogram;
	int range=256;//pocet jasu
	int c;

	//alokace pameti pro histogram a jeho vynulovani
	Hist = (int*) malloc(sizeof(int)*range);
	for (i=0;i<range;i++){
		Hist[i]=0;//vynulovani histgramu
	}


	for (i=0;i<Obr->height;i++){
		for (j=0;j<Obr->width;j++){
			Hist[(unsigned char)Obr->imageData[j+i*Obr->width]]++;//inkrementace prislusneho jasu
		}
	}

	if (visible==1){
		cvNamedWindow( "Histogram", 1 );
		for (i=0;i<=range;i++){
			if (max<Hist[i] && i!=potlac){
				max=Hist[i];
			}
		}
		Histogram= cvCreateImage( cvSize(range,300),8,1);//vytvori obraz pro zobrazeni histogramu 300 cely histogram se musi max/300
		for (i=0;i<=range;i++){
			if (i!=potlac){
				cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,300),cvRealScalar(255),0,8,0);
				cvLine(Histogram,cvPoint(i,(int)(300-Hist[i]/((float)max/300))),cvPoint(i,0),cvRealScalar(0),0,8,0);
			}
		}
		cvShowImage( "Histogram", Histogram);
		c = cvWaitKey(0);//cekani na klavesu v milisekundach
		cvDestroyWindow("Histogram");
		cvReleaseImage(&Histogram);
	}
	return(Hist);
}

IplImage* cvImageAdjust(IplImage *Obr, double x1,double y1,double x2,double y2)
{
	double k,q;//parametry primky
	int pole[256];//prepocet hodnot
	int i,j;
	IplImage *Vys;

	Vys = cvCreateImage( cvGetSize(Obr),8,Obr->nChannels);
	k=(y2-y1)/(x2-x1);
	q=y1-k*x1;
	for (i=0;i<256;i++){
		if (k*i/256+q<0){
			pole[i]=(unsigned char)0;
		}
		else{
			if (k*i/256+q>1){
				pole[i]=(unsigned char)255;
			}
			else{
				pole[i]=(unsigned char)(1+(k*i/256+q)*255);
			}
		}
	}
	for (i=0;i<Obr->widthStep;i++){
		for (j=0;j<Obr->height;j++){
			Vys->imageData[j*Obr->widthStep+i]=pole[(unsigned char)Obr->imageData[j*Obr->widthStep+i]];
		}
	}
	return (Vys);
}

IplImage* cvImageRotate(IplImage* Obr,int uhel,int orez)
{
	float m[6];
    CvMat M = cvMat( 2, 3, CV_32F, m );
    double prep;
	int vyska;
	int sirka;
	double uhelpom;
	IplImage *Vys;
	 
	
	if (orez==0){//obraz se zvetsi
		uhelpom=atan((double)(Obr->height/2)/(double)(Obr->width/2));//vypocita se pomocny uhel 
		prep=sqrt(Obr->width*Obr->width+Obr->height*Obr->height)/2;
		if (sin(uhelpom+uhel*CV_PI/180.)*prep>sin(uhelpom-uhel*CV_PI/180.)*prep){
			vyska=sin(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			vyska=sin(uhelpom-uhel*CV_PI/180.)*prep;
		}
		if (cos(uhelpom+uhel*CV_PI/180.)*prep>cos(uhelpom-uhel*CV_PI/180.)*prep){
			sirka=cos(uhelpom+uhel*CV_PI/180.)*prep;
		}
		else{
			sirka=cos(uhelpom-uhel*CV_PI/180.)*prep;
		}
		Vys= cvCreateImage( cvSize(sirka*2,vyska*2),8,Obr->nChannels);//vytvoreni vysledneho obrazu
	}
	else{
		Vys= cvCloneImage( Obr);//vytvoreni vysledneho obrazu
	}
	m[0] = (float)(cos(-uhel*CV_PI/180.));
    m[1] = (float)(sin(-uhel*CV_PI/180.));
    m[2] = Obr->width*0.5f;
    m[3] = -m[1];
    m[4] = m[0];
    m[5] = Obr->height*0.5f;

	

    cvGetQuadrangleSubPix( Obr, Vys, &M, 1, cvScalarAll(0));//provede se rotace
	
    return(Vys);
}

